// CompteDoc.cpp : implementation of the CCompteDoc class
//

#include "stdafx.h"
#include "Compte.h"
#include "Operation.h"
#include "ContFind.h"

#include "CompteDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCompteDoc

IMPLEMENT_DYNCREATE(CCompteDoc, CDocument)

BEGIN_MESSAGE_MAP(CCompteDoc, CDocument)
	//{{AFX_MSG_MAP(CCompteDoc)
	ON_COMMAND(ID_BEGIN, OnBegin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompteDoc construction/destruction

CCompteDoc::CCompteDoc()
{
	m_Solde = 0;
	m_Month = 1;
	m_Year = 2002;
}

CCompteDoc::~CCompteDoc()
{
	POSITION aPos;
	aPos = m_OpList.GetHeadPosition();

	while(aPos)
		delete m_OpList.GetNext(aPos);

	m_OpList.RemoveAll();
}

BOOL CCompteDoc::OnNewDocument()
{
	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	if (!CDocument::OnNewDocument())
		return FALSE;

	POSITION aPos;
	aPos = m_OpList.GetHeadPosition();

	while(aPos)
		delete m_OpList.GetNext(aPos);

	m_OpList.RemoveAll();

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CCompteDoc serialization

void CCompteDoc::Serialize(CArchive& ar)
{
	m_OpList.Serialize(ar);

	if (ar.IsStoring())
	{
		ar << m_Solde
			 << m_Month
			 << m_Year;
	}
	else
	{
		ar >> m_Solde
			 >> m_Month
			 >> m_Year;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCompteDoc diagnostics

#ifdef _DEBUG
void CCompteDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CCompteDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCompteDoc commands

void CCompteDoc::Sort()
{
	if(m_OpList.GetCount() < 2)
		return;

	POSITION aPos;

	COperation* pLast;
	CTime Last;
	COperation* pCurrent;
	CTime Current;

	long ValueLast, ValueCurrent, Limit1, Limit2;

	Limit1 = m_OpList.GetCount() - 1;

	for(long i = 1; i <= Limit1; i++)
	{

		aPos = m_OpList.GetHeadPosition();
		pLast = m_OpList.GetNext(aPos);
		Limit2 = m_OpList.GetCount() - i;
		
		for(long j = 1; j <= Limit2; j++)
		{
			pCurrent = m_OpList.GetNext(aPos);
			Current = pCurrent->GetDate();
			Last = pLast->GetDate();

			ValueLast = (Last.GetYear() * 10000) + (Last.GetMonth() * 100) + Last.GetDay();
			ValueCurrent = (Current.GetYear() * 10000) + (Current.GetMonth() * 100) + Current.GetDay();

			if(ValueLast > ValueCurrent)
				Swap(pLast, pCurrent);
			else
				pLast = pCurrent;
		}
	}
}

void CCompteDoc::Swap(COperation *pFirst, COperation *pSecond)
{
	POSITION First, Second;

	First = m_OpList.Find(pFirst);
	Second = m_OpList.Find(pSecond);

	m_OpList.SetAt(Second, pFirst);
	m_OpList.SetAt(First, pSecond);
}

void CCompteDoc::CalcSolde()
{
	COperation* pOp = NULL;
	POSITION aPos = m_OpList.GetHeadPosition();
	float CurrentSolde = m_Solde;

	while(aPos)
	{
		pOp = m_OpList.GetNext(aPos);
		CurrentSolde += pOp->GetOperation();

		pOp->PutSolde(CurrentSolde);
	}
}

void CCompteDoc::OnBegin() 
{
	CContFind bDlg;
	bDlg.m_Message = CString("Pour commencer un nouveau compte, double-cliquer dans la zone vierge.");

	bDlg.DoModal();
}
