// CompteDoc.h : interface of the CCompteDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMPTEDOC_H__CB037650_CB2B_4CA5_A788_5268C5D432BF__INCLUDED_)
#define AFX_COMPTEDOC_H__CB037650_CB2B_4CA5_A788_5268C5D432BF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Operation.h"

class CCompteDoc : public CDocument
{
protected: // create from serialization only
	CCompteDoc();
	DECLARE_DYNCREATE(CCompteDoc)

// Attributes
public:
	float m_Solde;
	int m_Month;
	int m_Year;

protected:
	CTypedPtrList<CObList, COperation*> m_OpList;

// Operations
public:

	POSITION GetListHeadPosition() const
	{ return m_OpList.GetHeadPosition(); }

	POSITION GetListTailPosition() const
	{ return m_OpList.GetTailPosition(); }

	COperation* GetNext(POSITION& aPos) const
	{ return m_OpList.GetNext(aPos); }

	COperation* GetPrev(POSITION& aPos) const
	{ return m_OpList.GetPrev(aPos); }

	int GetCount() const
	{ return m_OpList.GetCount(); }

	POSITION FindIndex(long& i) const
	{ return m_OpList.FindIndex(i); }

	COperation* GetAt(POSITION& aPos) const
	{ return m_OpList.GetAt(aPos); }

	COperation* GetAt(long& aPos) const
	{ return m_OpList.GetAt(FindIndex(aPos)); }

	void SetAt(POSITION aPos, COperation* pOp)
	{
		m_OpList.SetAt(aPos, pOp);
		SetModifiedFlag();
		Sort();
		CalcSolde();
	}

	void DeleteOp(long NumOp)
	{
		m_OpList.RemoveAt(FindIndex(NumOp));
		SetModifiedFlag();
	}

	void Check(long aPos)
	{
		(m_OpList.GetAt(m_OpList.FindIndex(aPos)))->PutCheck();
		SetModifiedFlag();
	}

	void AddOp(COperation* pOp)
	{
		m_OpList.AddTail(pOp);
		SetModifiedFlag();
		Sort();
		CalcSolde();
	}

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCompteDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCompteDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CCompteDoc)
	afx_msg void OnBegin();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void CalcSolde();
	void Swap(COperation* pFirst, COperation* pSecond);
	void Sort();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COMPTEDOC_H__CB037650_CB2B_4CA5_A788_5268C5D432BF__INCLUDED_)
