// Operation.cpp: implementation of the COperation class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Compte.h"
#include "Operation.h"
#include "Constantes.h"

IMPLEMENT_SERIAL(COperation, CObject, VERSION_NUMBER)

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

COperation::COperation()
{
	m_Checked = true;
	m_Date = CTime(2000, 1, 1);
	m_Type = CString(CHEQUE);
	m_Operation = 55;
	m_Libelle = CString("Libell");
	m_Solde = 0;
}

COperation::COperation(const BOOL Check, const CTime Date, const CString Libelle, const CString Type, const float Operation)
{
	m_Checked = Check;
	m_Date = CTime(Date);
	m_Type = CString(Type);
	m_Operation = Operation;
	m_Libelle = CString(Libelle);
	m_Solde = 0;
}

COperation::~COperation()
{
}

void COperation::Draw(CDC* pDC, CPoint aPos) const
{
	if(m_Solde < 0)
		pDC->SetTextColor(RGB(200,0,0));
	else
		pDC->SetTextColor(RGB(0,0,150));

	aPos.y += DECAL_Y;

	//CHECK
	if(m_Checked)
		pDC->TextOut(aPos.x + DECAL_CHECK, aPos.y, "Ok");
	/*else
		pDC->TextOut(aPos.x + DECAL_CHECK, aPos.y, "No");*/

	aPos.x += SIZE_CHECK;

	//DATE
	char Date[11];

	itoa(m_Date.GetDay(), Date, 10);
	itoa(m_Date.GetMonth(), &Date[3], 10);
	itoa(m_Date.GetYear(), &Date[6], 10);

	Date[2] = Date[5] = '/';
	Date[10] = '\0';

	for(int i = 0; i < 10; i++)
	{
		if(Date[i] == '\0')
			Date[i] = ' ';
	}

	pDC->TextOut(aPos.x + DECAL_DATE, aPos.y, Date);
	aPos.x += SIZE_DATE;

	//LIBELLE
	pDC->TextOut(aPos.x + DECAL_LIBELLE, aPos.y, m_Libelle);

	aPos.x += SIZE_LIBELLE;

	//TYPE
	pDC->TextOut(aPos.x + DECAL_TYPE, aPos.y, m_Type);
	aPos.x += SIZE_TYPE;

	//OPERATION
	char Operation[10];
	gcvt(m_Operation, 7, Operation);

	pDC->TextOut(aPos.x + DECAL_OPERATION, aPos.y, Operation);

	aPos.x += SIZE_OPERATION;

	//SOLDE
	char Solde[10];
	gcvt(m_Solde, 7, Solde);
	pDC->TextOut(aPos.x + DECAL_SOLDE_E, aPos.y, Solde);

}

void COperation::Serialize(CArchive& ar)
{
	CObject::Serialize(ar);

	if(ar.IsStoring())
	{
		ar << m_Checked
			 << m_Date
			 << m_Libelle
			 << m_Type
			 << m_Operation
			 << m_Solde;
	}
	else
	{
		ar >> m_Checked
			 >> m_Date
			 >> m_Libelle
			 >> m_Type
			 >> m_Operation
			 >> m_Solde;
	}
}